<?php

class TerminationstatusModel {
  public $code = null;
  public $name = null;
  
  public $create_by = null;
  public $edit_by = null;
  public $create = null;
  public $edit = null;

  public static function create(Array $data) {
    $model = new Terminationstatus();
    
    foreach($data as $field => $value) {
      if(property_exists(get_called_class(), $field)) {
        $model ->$field = $value;
      }
    }
    
    $me = new User();
    $me->loadMe();

    if($model->create_by === null) {
      $model->create_by = $me->id;
    }
    if($model->edit_by === null) {
      $model->edit_by = $me->id;
    }
    
    return $model;
  }
  
  public static function getOne($id) {
    if(!is_numeric($id) || !$id) {
      throw new Exception("Invalid number", 400);
    }
    $item = [];
    $db = FronkDB::singleton();
    
    $res = $db->select("Terminationstatus", "*", "id=$id LIMIT 1");
    if($db->num_rows($res)) {
      $data = $db->fetch_object($res);
      $item = new Terminationstatus($data);
    }
    return $item;
  }
  
  public static function getAll() {
    $items = [];
    
    $db = FronkDB::singleton();
    
    $res = $db->select("Terminationstatus", "*", "1=1 ORDER BY code,name");
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Terminationstatus($data);
      }
    }
    return $items;
    
  }
  
  public static function search($filter) {
    $items = [];
    $db = FronkDB::singleton();
    
    $where = self::getSqlFilter($filter);
    $res = $db->select("Terminationstatus", "*", $where);
    if($db->num_rows($res)) {
      while($data = $db->fetch_object($res)) {
        $items[] = new Terminationstatus($data);
      }
    }
    return $items;
  }
  
  private function getSqlFilter($filter) {
    $where = "1=1 ";
    
    if(array_key_exists("code", $filter)) {
      $code = FronkDB::singleton()->escape($filter['code']);
      $where .= " AND code='$code'";
    }
    
    if(array_key_exists("name", $filter)) {
      $name = FronkDB::singleton()->escape($filter['name']);
      $where .= " AND name='$name'";
    }
    
    //var_dump($filter, $where);exit;
    return $where;
  }
  
}